/*
Data una sequenza di byte rappresentante un pacchetto IP, scrivere un programma in linguaggio C che verifica
se si tratta di un pacchetto ICMP.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "getBytesFromTextFile.c"

#define IPPROTOCOL_ICMP (0x01)
#define ICMP_TYPE_ECHOREQUEST (8)
#define ICMP_CODE_ECHOREQUEST (0)

int main (void)
{
  unsigned char* pb;
  int i,n;
  unsigned char byte;
  unsigned int idxIPData;

  pb = getBytesFromTextFile("icmp.txt",&n);
  printf("Ip frame:\n");
  for (i=0; i<n; i++)
  {
    printf("%02x ",pb[i]);
  }

  byte = pb[0] & 0x0f;
  idxIPData = byte*4;
  printf("\nHIL: %d, percio' i dati IP iniziano dall'indice: %d",byte, idxIPData);

  byte = pb[9];
  printf("\nIP Protocol: %02xh",byte);
  if (byte==IPPROTOCOL_ICMP)
  {
    unsigned char Type, Code;

    printf("\n\tPacchetto ICMP (%02x)",byte);
    Type = pb[idxIPData]; Code = pb[idxIPData+1];
    printf("\n\tType: %02xh Code: %02xh",Type,Code);
    if (Type == ICMP_TYPE_ECHOREQUEST && Code==ICMP_CODE_ECHOREQUEST)
    {
      printf(" (Echo Request)");
    }
  }
  else printf("\n\tNon  un pkt ICMP (%02xh)",byte);

  return 0;
}
